-- Map Leader as spacebar
vim.g.mapleader = " "

-- Big cursor
vim.opt.guicursor = ""

-- Print lines
vim.opt.nu = true
-- Print lines relative
vim.opt.relativenumber = true
vim.opt.scrolloff = 8

-- Indentation to be 4 spaces
vim.opt.tabstop = 4
vim.opt.softtabstop = 4
vim.opt.shiftwidth = 4
-- Automatically indents depending on the line before
vim.opt.expandtab = true
vim.opt.smartindent = true

-- Do not go to the a new line when screnn doesn't fit
vim.opt.wrap = false

-- Diabslebing vim's swap and backup as we are using undotree
vim.opt.swapfile = false
vim.opt.backup = false
-- Directory for undotree
vim.opt.undodir = os.getenv("HOME") .. "/.vim/undodir"
vim.opt.undofile = true

-- Guidance to hihlight your seraches incremetally
vim.opt.hlsearch = false
vim.opt.incsearch = true

vim.opt.termguicolors = true

-- To show whne there is an issue found by LPS simmilar to GBD
vim.opt.signcolumn = "yes"
vim.opt.isfname:append("@-@")

-- Column as delimitor
vim.opt.colorcolumn = "80"

-- Fast update times
vim.opt.updatetime = 50
