Config { font            = "xft:Ubuntu:weight=bold:pixelsize=26:antialias=true:hinting=true"
       , additionalFonts = [ "xft:Mononoki:pixelsize=18:antialias=true:hinting=true"
                           , "xft:Font Awesome 6 Free Solid:pixelsize=30"
                           , "xft:Font Awesome 6 Brands:pixelsize=30"
                           ]
       , bgColor			= "#282c34"
       , fgColor			= "#ff6c6b"
       , alpha				= 255
       , position			= TopSize L 100 35
       , textOffset			= -1
       , iconOffset			= -1
       , lowerOnStart		= True
       , persistent			= True
       , hideOnStart		= False
       , iconRoot			= "."
       , allDesktops		= True
       , overrideRedirect	= True
       , commands = [
                        -- Echos a "penguin" icon in front of the kernel output.
                      Run Com "echo" ["<fn=3>\xf17c</fn>"] "penguin" 36000
                        -- Get kernel version (script found in .local/bin)
                    , Run Com "/home/key/.config/xmobar/get_kernel.sh" [] "kernel" 36000
                        -- Echos a "rj45" icon in front of the ip output.
                    , Run Com "echo" ["<fn=2>\xf796</fn>"] "rj" 36000
						-- Get the Current IP address
					, Run Com "/home/key/.config/xmobar/ip.sh" [] "myip" 150 
				
					, Run Com "/home/key/.config/xmobar/battery.sh" [] "battery" 150 
					
						-- Dy Newtoek consumption
					, Run DynNetwork [	"--template" , "<dev>: <tx>kB/s|<rx>kB/s"
									,	"--Low"      , "5000"       -- units: kB/s
									,	"--High"     , "50000"       -- units: kB/s
									,	"--low"      , "darkgreen"
									,	"--normal"   , "darkorange"
									,	"--high"     , "darkred"
					] 10
                        -- Cpu usage in percent
                    , Run Cpu ["-t", "<fn=2>\xf108</fn>  cpu: (<total>%)","-H","50","--high","red"] 20
                        -- Ram used number and percent
                    , Run Memory ["-t", "<fn=2>\xf233</fn>  mem: <used>M (<usedratio>%)"] 20
                        -- Disk space free
                    , Run DiskU [("/", "<fn=2>\xf0c7</fn>  hdd: <free> free")] [] 60
                        -- Echos an "up arrow" icon in front of the uptime output.
                    , Run Com "echo" ["<fn=2>\xf0aa</fn>"] "uparrow" 3600
                        -- Uptime
                    , Run Uptime ["-t", "uptime: <days>d <hours>h"] 360
                        -- Echos a "bell" icon in front of the pacman updates.
                    , Run Com "echo" ["<fn=2>\xf0f3</fn>"] "bell" 3600
                        -- Check for pacman updates (script found in .local/bin)
                    , Run Com ".local/bin/pacupdate" [] "pacupdate" 36000
                        -- Echos a "battery" icon in front of the pacman updates.
                    , Run Com "echo" ["<fn=2>\xf242</fn>"] "baticon" 3600
                        -- Battery
                    , Run Date "<fn=2>\xf017</fn>  %b %d %Y - (%H:%M) " "date" 50
                        -- Prints out the left side items such as workspaces, layout, etc.
                    , Run UnsafeStdinReader
                    ]
       , sepChar = "%"
       , alignSep = "}{"
	   , template = "<box type=Bottom width=2 mb=2 color=#51afef><fc=#51afef>%penguin% %kernel%</fc></box> <box type=Bottom width=2 mb=2 color=#DA8012><fc=#DA8012> %rj% %dynnetwork% IP:%myip%</fc></box>}<box type=Bottom width=2 mb=2 color=#1259DA><fc=#1259DA>%date%</fc></box>{<box type=Bottom width=2 mb=2 color=#ecbe7b><fc=#ecbe7b><action=`alacritty -e htop`>%cpu%</action></fc></box>   "

       }

