#!/bin/bash

COLORS_SCRIPT_DIR=$(cd -- "$(dirname -- "${BASH_SOURCE[0]}")" &>/dev/null && pwd)

black='30'
red='31'
green='32'
brown='33'
blue='34'
purple='35'
cyan='36'
lightGray='37'
yellow='1;33'
lightGreen='1;32'

fontNormal='0'
fontBold='1'
fontUnderline='4'
fontBlink='5'
fontVideo='7'

colorDelimiterBegin='\e['
colorDelimiterEnd='m'
colorStop='\e[0m'

themeGreetings="$blue"
themeFocus="$fontBold"
themeInput="$cyan"
themeUserInput="$cyan"
themeSelect="$fontUnderline"
themeSuccess="$green"
themeError="$red"
themeIndication="$purple"
themeInstall="$yellow"
themeSkip="$lightGreen"
themeComment="$lightGreen"

color_start() {
  local -n ref1=$1
  printf $colorDelimiterBegin$ref1$colorDelimiterEnd
}

color_stop() {
  printf $colorDelimiterBegin$fontNormal$colorDelimiterEnd
  printf $colorStop
}
